﻿/*
*	ていすてぃ！
*/


class ChargeEffect01 extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "32.png", "ChargeEffect01", 10, 32*3, 32*7, 32, 32 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture		= "ChargeEffect01"
		obj.BlendMode	= AB_ADD
		obj.Scale2D.Set( 0.12, 0.25 )

		// 登録
		GameObjectBase.constructor( obj, "ChargeEffect01", eObjType.Effect )
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		o.F0 += 0.04
		if( o.F0 > 1 ) o.Valid = false
		
		o.Speed.Y = 4.5 * sin( o.F0 * PI ) * -1
		
		if( o.F0 > 0.5 ) o.Color.a -= 0.07
	}
}


class ChargeEffect02 extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "ring.png", "ChargeEffect02", 10, 0, 0, 64, 64 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture		= "ChargeEffect02"
		obj.BlendMode	= AB_ADD
		obj.Scale2D.Set( 0 )

		// 登録
		GameObjectBase.constructor( obj, "ChargeEffect02", eObjType.Effect )
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		if( o.Link.HasParent ) o.Pos = o.Link.Parent.Pos
		o.Scale2D.Add( 0.35 )
		
		if( o.Scale2D.X > 2 ){
			o.Scale2D.Set( 2 )
			o.Color.a -= 0.1
			if( o.Color.a <= 0 ) o.Valid = false
		}
	}
}


ChargeEffect01()
ChargeEffect02()
