﻿/*
*	あたっく
*/


enum eAttackState
{
	Ready,	// デフォルト
	Kick01,	// 
	Kick02,	// 
	Shot01,	// 
}


class Attack
{
	o	= null
	
	ing		= false
	state	= eAttackState.Ready
	state2	= -1
	frame	= 0
	canJump	= true
	isChain	= false
	
	


	/*
	*	
	*/
	function Init(obj)
	{
		o	= obj
	}
	
	
	/*
	*	あっぷでーと
	*/
	function Update()
	{
	}


	/*
	*	
	*/
	function Action(pad)
	{
		if( ing ){
			++frame
			
			local totalFrame	= 0
			local state2Old		= state2
			state2 = -1
			
			switch( state ){
				case eAttackState.Ready:
					break
					
				case eAttackState.Kick01:
					
					if( o.ColDir & DIR_DOWN ) o.Speed.X = 0
					
					foreach(i, v in [ 3, 3, 6, 3, 3, 3 ])
						if( frame < (totalFrame += v) ){ state2 = i; break }
					
					// 切り替わりでうんたん
					if( state2 != state2Old ){
						switch( state2 ){
							case -1:
								this.Finish()
								break
						}
					}
					break
					
				case eAttackState.Kick02:
					
					if( o.ColDir & DIR_DOWN ) o.Speed.X = 0
					
					foreach(i, v in [ 2, 2, 2, 3, 5, 3, 3, 3 ])
						if( frame < (totalFrame += v) ){ state2 = i; break }
					
					// 切り替わりでうんたん
					if( state2 != state2Old ){
						switch( state2 ){
							case -1:
								o.Pos.X -= 6 * (o.Dir & DIR_LEFT ? -1 : 1)
								this.Finish()
								break
						}
					}
					break
					
				case eAttackState.Shot01:
					
					foreach(i, v in [ 3, 3, 3, 3 ])
						if( frame < (totalFrame += v) ){ state2 = i; break }
						
					// 切り替わりでうんたん
					if( state2 != state2Old ){
						switch( state2 ){
							case -1:
								this.Finish()
								break
						}
					}
					break
			}
		}
	}
	
	
	/*
	*	
	*/
	function Atk(pad)
	{
		if( pad.IsPush( PAD_BUTTON_02 ) ){
		
			switch( state ){
				case eAttackState.Ready:
					ing		= true
					frame	= -1
					state	= eAttackState.Shot01
					state2	= -1
					break
					
				case eAttackState.Kick01:
					break
					
				case eAttackState.Kick02:
					break
					
				case eAttackState.Shot01:
					break
			}
		}
		else if( pad.IsPush( PAD_BUTTON_03 ) ){
		
			switch( state ){
				case eAttackState.Ready:
					ing		= true
					frame	= -1
					state	= eAttackState.Kick01
					state2	= -1
					isChain	= false
					break
					
				case eAttackState.Kick01:
					isChain = true
					break
					
				case eAttackState.Kick02:
					break
					
				case eAttackState.Shot01:
					break
			}
		}
		
		
		// れんさ
		switch( state ){
			case eAttackState.Ready:
				break
				
			case eAttackState.Kick01:
				if( isChain ){
					switch( state2 ){
						case 5:
							ing		= true
							frame	= -1
							state	= eAttackState.Kick02
							state2	= -1
							isChain	= false
							break
					}
				}
				break
				
			case eAttackState.Kick02:
				break
				
			case eAttackState.Shot01:
				break
		}
	}
	
	
	/*
	*	
	*/
	function Draw(srcPoint)
	{
		switch( state ){
			case eAttackState.Ready:
				break
				
			case eAttackState.Kick01:
			
				// 位置ずらし
				switch( state2 ){
					case 1:
					case 2:
					case 3:
						o.Dst.X -= 2 * (o.Dir & DIR_LEFT ? -1 : 1)
						break
				}
				
				srcPoint.X = [ 0, 1, 2, 3, 4, 5 ][ state2 ]
				srcPoint.Y = 9
				break
				
			case eAttackState.Kick02:
			
				// 位置ずらし
				switch( state2 ){
					case 4:
						o.Dst.X += 4 * (o.Dir & DIR_LEFT ? -1 : 1)
						break
					case 5:
					case 6:
					case 7:
						o.Dst.X -= 4 * (o.Dir & DIR_LEFT ? -1 : 1)
						break
				}
				
				srcPoint.X = [ 0, 1, 2, 3, 4, 5, 0, 1 ][ state2 ]
				srcPoint.Y = [ 10, 11 ][ (state2 < 6 ? 0 : 1) ]
				break
				
			case eAttackState.Shot01:
				srcPoint.X = [ 0, 1, 2, 3 ][ state2 ]
				srcPoint.Y = 7
				break
		}
	}
	
	
	/*
	*	
	*/
	function Finish()
	{
		state	= eAttackState.Ready
		frame	= 0
		ing		= false
		state2	= -1
	}
}
