﻿/*
*	ステージロード
*/

{
	local tex = My.CTextureInterface()
	local texState = STextureState()
	
	local xau = My.CXAudio()
	local sndInfo = SSoundInfo()
	
	
	// ゲージ
	tex.CreateTexture( "gauge.png", texState )
		.Regist( "gauge", 20000, 0, 0, 0, 0 )
	
	
	// はいけい
	tex.CreateTexture( "aiuek.png", texState )
		.Regist( "bg01", 0, 0, 0, 2048, 1024 )
	
	
	// めーっせーじういんどう
	tex.CreateTexture( "TalkWindow.png", texState )
		.Regist( "TalkWindow", 20000, 0, 0, 256, 64 )
		
	// 
	sndInfo.Type = SOUND_TYPE_SE
	xau.LoadFile( "stageClear", "goal.wav", sndInfo, true )
	sndInfo.Volume = 0.5
	xau.LoadFile( "slime04", "slime04.wav", sndInfo, true )
	sndInfo.Volume = 1.0
	xau.LoadFile( "slime05", "slime05.wav", sndInfo, true )
	xau.LoadFile( "needle", "needle.wav", sndInfo, true )
	//xau.LoadFile( "jump", "jump.wav", sndInfo, true )
	sndInfo.Volume = 0.5
	//xau.LoadFile( "jump", "jump02.wav", sndInfo, true )
	xau.LoadFile( "jump", "jump03.wav", sndInfo, true )
	sndInfo.Volume = 1.0
	//xau.LoadFile( "fall", "fall01.wav", sndInfo, true )
	xau.LoadFile( "back_step2", "back_step2.wav", sndInfo, true )
	sndInfo.PlayLength = 19000
	xau.LoadFile( "back_step", "back_step.wav", sndInfo, true )
	
	sndInfo.Volume = 0.4
	sndInfo.PlayLength = 0
	sndInfo.LoopBegin = 56000
	sndInfo.LoopCount = 255
	xau.LoadFile( "dush", "dush.wav", sndInfo, true )
}


// まっぷこりじょん
dofile( "./data/squirrel/stageMap/open.nut" )

// 相方のメッセージ
dofile( "./data/squirrel/partnerMsg/open.nut" )

// おぶじぇくと
dofile( "./data/squirrel/object/open.nut" )
