﻿/*
*	落下とげげげげええげ
*/


class FallNeedle01 extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "32.png", "FallNeedle01", 10, 32*6, 32*4, 32, 32 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "FallNeedle01"
		
		// コリジョン設定
		local detail = GameObject.SColDetail.ctorRect( -16, -16, 16, 16 )
		detail.Flag = (ColFlagD.ColMap | ColFlagD.ColObj)
		detail.Target = eObjType.Player
		detail.Damage = 100
		obj.Col.PushDetail( detail )
		
		// 登録
		GameObjectBase.constructor( obj, "FallNeedle01", eObjType.Enemy )
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		local player = GameObject.GetPlayer()
		
		if( player.Valid ){
			if( abs( player.Pos.X - o.Pos.X ) < 64 ) o.Speed.Y += 0.01
		}
		
		if( o.Speed.Y != 0 ) o.Speed.Y += 0.2
		
		if( o.ColDir ){
			local param = GameObject.FindIObjectParam( "FallNeedleEffect01" )
			
			for(local i=0; i<5; ++i){
				local a = SPoint2DF.ctor( (rand() % 400) / 100.0 - 2, - (rand() % 600) / 100.0 )
				GameObject.CreateObjectFromParam( param, o.Pos, DIR_INVALID ).Speed = a
			}
				
			o.Valid = false
		}
	}
}


class FallNeedleEffect01 extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "32.png", "FallNeedleEffect01", 10, 32*6, 32*5, 32, 32 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "FallNeedleEffect01"
		
		// 登録
		GameObjectBase.constructor( obj, "FallNeedleEffect01", eObjType.Effect )
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		o.Speed.Y += 0.2
	}
}


FallNeedle01()
FallNeedleEffect01()
