﻿/*
*	まじっくぺっと？
*/


class MagicPet01 extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "enemy01.png", "MagicPet01", 10, 64*1, 32*0, 64, 32 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "MagicPet01"
		
		// コリジョン設定
		local detail = GameObject.SColDetail.ctorRect( -16, -16, 16, 16 )
		detail.Flag = (ColFlagD.ColMap | ColFlagD.ColObj)
		detail.Target = eObjType.Player
		detail.Damage = 100
		obj.Col.PushDetail( detail )
		
		// 登録
		GameObjectBase.constructor( obj, "MagicPet01", eObjType.Enemy )
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		o.L0 = 0
		
		if( o.L0 == 0 ){
			o.Speed.Y += 0.2
			if( o.ColDir & (DIR_LEFT | DIR_RIGHT) ) o.Dir = (o.Dir == DIR_LEFT ? DIR_RIGHT : DIR_LEFT)
			
			o.Speed.X = 2 * (o.Dir == DIR_LEFT ? -1 : 1)
		}
		else if( o.L0 == 1 ){
			o.Angle += 0.05 * (o.Dir == DIR_LEFT ? -1 : 1)
		}
		else{
		}
	}
	
	
	/*
	*	描画
	*/
	function Draw(o)
	{
		o.Turn.X = (o.Dir == DIR_LEFT)
		o.Src.X += o.Src.W * 1
		
		++o.L1
		
		local i = 0
		foreach(n in [ 0, 1, 2, 3 ]){
			if( o.L1 < 8*(i+1) ){
				o.Src.Y += o.Src.H * n
				return
			}
			++i
		}
		
		o.L1 = 0
	}
}


MagicPet01()
