﻿/*
*	とげげげげええげ
*/


class Needle extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "mapchi_obj.png", "Needle", 50005, 40*1, 40*0, 40, 40 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "Needle"
		
		// 登録
		GameObjectBase.constructor( obj, "Needle", eObjType.Enemy )
	}
	
	
	/*
	*	初期化
	*/
	function Init(o)
	{
		local detail = null
		if     ( o.Dir & DIR_DOWN  ){ o.Angle = 0.25; detail = GameObject.SColDetail.ctorRect( -16, -20, 16, -6 ) }
		else if( o.Dir & DIR_LEFT  ){ o.Angle = 0.5;  detail = GameObject.SColDetail.ctorRect(   6, -16, 20, 16 ) }
		else if( o.Dir & DIR_RIGHT ){ o.Angle = 0.0;  detail = GameObject.SColDetail.ctorRect( -20, -16, -6, 16 ) }
		else                        { o.Angle = 0.75; detail = GameObject.SColDetail.ctorRect( -16,   6, 16, 20 ) }
		detail.Target = eObjType.Player
		detail.Damage = 100
		o.Col.PushDetail( detail )
	}
	
	
	/*
	*	
	*/
	function Col(o1, o2, c1, c2)
	{
		local xau = My.CXAudio()
		local se = xau.Find("needle")
		se.Play()
	}
}


Needle()
