﻿/*
*	
*/


gehehe <-
{
	state		= 0,
	frame		= -1,
	targetPos	= SPoint2DF(),
	pikohan		= null,
}


class GeheheMaster extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "Gehehe.png", "GeheheMaster", 60, 64*0, 64*0, 64, 64 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "GeheheMaster"
		obj.Def		= 9999
		obj.HP		= 10000
		
		// コリジョン設定
		local detail = GameObject.SColDetail.ctorRect( -12, -16, 12, 26 )
		detail.Flag = (ColFlagD.ColMap | ColFlagD.ColObj)
		detail.Target = eObjType.Player
		detail.Damage = 100
		obj.Col.PushDetail( detail )
		
		// 登録
		GameObjectBase.constructor( obj, "GeheheMaster", eObjType.Enemy )
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		++gehehe.frame
		
		local oldSpeed = o.Speed.Clone()
		o.Speed.Y += 0.4
		//gehehe.state = 5
		
		switch( gehehe.state ){
			case 0:
				if( gehehe.frame >= 60 ){ ++gehehe.state; gehehe.frame = -1 }
				break
				
			case 1:
				
				switch( gehehe.frame ){
					case 0:
						foreach(v in [ -6.5, -5.5, -4.5 ])
							LaserBomb.Make( o.Pos, v, -15 )
						break
						
					case 40:
						foreach(v in [ -4, -3, -2, -1 ])
							LaserBomb.Make( o.Pos, v, -15 )
						break
						
					case 150:
						++gehehe.state
						gehehe.frame = -1
						break
				}
				break
				
			case 2:
				switch( gehehe.frame ){
					case 0:
						foreach(v in [ -64*5, -64*4 ])
							Laser.Make( o.Pos + SPoint2DF.ctor( -48, v ), 0.5, 63 )
						break
					case 35:
						foreach(v in [ -64*3, -64*2 ])
							Laser.Make( o.Pos + SPoint2DF.ctor( -48, v ), 0.5, 63 )
						break
					case 75:
						foreach(v in [ -64*1, -64*0 ])
							Laser.Make( o.Pos + SPoint2DF.ctor( -48, v ), 0.5, 63 )
						break
					case 120:
						++gehehe.state
						gehehe.frame = -1
						break
				}
				break
				
			case 3:
				switch( gehehe.frame ){
					case 0:
						foreach(v in [ -64*5, -64*4, -64*3 ])
							Laser.Make( o.Pos + SPoint2DF.ctor( -48, v ), 0.5, 63 )
						break
					case 50:
						foreach(v in [ -64*2, -64*1, -64*0 ])
							Laser.Make( o.Pos + SPoint2DF.ctor( -48, v ), 0.5, 63 )
						break
					case 120:
						++gehehe.state
						gehehe.frame = -1
						break
				}
				break
				
			case 4:
				if( (gehehe.frame > 60) && (gehehe.frame % 6 == 0) ){
					//Laser.Make( o.Pos + SPoint2DF.ctor( rand() % 64 - 96, rand() % 64 - 256 ), 0.5, 63 )
					
					Laser.Make( gehehe.targetPos + SPoint2DF.ctor( rand() % 256 - 128, -400 ), 0.25, 63 )
				}
				
				switch( gehehe.frame ){
					case 0:
						gehehe.targetPos = GameObject.GetPlayer().Pos.Clone()
						break
					case 180:
						++gehehe.state
						gehehe.frame = -1
						break
				}
				break
				
			case 5:
				if( gehehe.frame < 60 ){
					o.Pos.X += 8 * (o.Dir & DIR_LEFT ? -1 : 1)
					local s = gehehe.targetPos.X - o.Pos.X
					if( abs(s) < 32 ){ gehehe.frame = 150 }
				}
				
				switch( gehehe.frame ){
					case 0:
						gehehe.targetPos = GameObject.GetPlayer().Pos
						
						o.Dir = (gehehe.targetPos.X < o.Pos.X ? DIR_LEFT : DIR_RIGHT)
						
						gehehe.pikohan = Pikohan.Make( o.Pos, o.Dir )
						o.Link.Link( gehehe.pikohan )
						break
					case 150:
						++gehehe.pikohan.L0
						break
					case 210:
						gehehe.state = 0
						gehehe.frame = -1
						break
				}
				break
		}
	}
	
	
	/*
	*	描画
	*/
	function Draw(o)
	{
		o.Turn.X = (o.Dir & DIR_LEFT)
		
		switch( gehehe.state ){
			case 0:
				break
				
			case 1:
				break
				
			case 2:
				break
		}
	}
}


GeheheMaster()
