﻿/*
*	
*/


class PlayerShadow extends GameObjectBase
{
	function Make(pos, src)
	{
		local param = GameObject.FindIObjectParam( "PlayerShadow" )
		local o = GameObject.CreateObjectFromParam( param, pos, DIR_INVALID )
		
		o.Src	= src
	}
	
	
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "sheeps.png", "PlayerShadow", 50000, 0, 0, 80, 80 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "PlayerShadow"
		obj.Color.Set( 0.2, 0.2, 0.5, 0.8 )

		// 登録
		GameObjectBase.constructor( obj, "PlayerShadow", eObjType.Effect )
	}


	/*
	*	描画
	*/
	function Draw(o)
	{
		o.Color.a -= 0.04
		if( o.Color.a <= 0 ) o.Valid = false
	}
}


PlayerShadow()
