﻿/*
*	まっぷ
*/

/*
[ -1,  0     ]
[  7,  8,  9 ]
[  4,  5,  6 ]
[  1,  2,  3 ]
*/

local tipSize = 40

local a = [
	// [ id, type, dir, sx, sy, ex, ey ]
	[  0, 1, DIR_ALL,					0, 0, tipSize, tipSize ],
	
	[  9, 1, (DIR_DOWN | DIR_LEFT),		0, 0, tipSize, tipSize ],
	[  8, 1, DIR_DOWN,					0, 0, tipSize, tipSize ],
	[  7, 1, (DIR_DOWN | DIR_RIGHT),	0, 0, tipSize, tipSize ],
	[  6, 1, DIR_LEFT,					0, 0, tipSize, tipSize ],
	[  5, 1, DIR_ALL,					0, 0, tipSize, tipSize ],
	[  4, 1, DIR_RIGHT,					0, 0, tipSize, tipSize ],
	[  3, 1, (DIR_UP | DIR_LEFT),		0, 0, tipSize, tipSize ],
	[  2, 1, DIR_UP,					0, 0, tipSize, tipSize ],
	[  1, 1, (DIR_UP | DIR_RIGHT),		0, 0, tipSize, tipSize ],
	
	[ 10, 1, (DIR_ALL ^ DIR_LEFT),		0, 0, tipSize, tipSize ],
	[ 11, 1, (DIR_UP | DIR_DOWN),		0, 0, tipSize, tipSize ],
	[ 12, 1, (DIR_ALL ^ DIR_RIGHT),		0, 0, tipSize, tipSize ],
	
	[ 13, 1, (DIR_ALL ^ DIR_UP),		0, 0, tipSize, tipSize ],
	[ 14, 1, (DIR_LEFT | DIR_RIGHT),	0, 0, tipSize, tipSize ],
	[ 15, 1, (DIR_ALL ^ DIR_DOWN),		0, 0, tipSize, tipSize ],
]

local b = [
	[ -1,  0,  8,  8,  8,    8,  7,  8,  9, 13,   13 ],
	[  7,  8,  9, 13, -1,   -1,  4, -1,  6, 14,   14 ],
	[  4, -1,  6, 14,  4,    6,  1,  2,  3, 15,   15 ],
	[  1,  2,  3, 15,  1,    3, 10, 11, 12,  5,   -1 ],
	[ 10, 11, 12,  5, -1,   -1,  7,  8,  9, 13,   -1 ],
	
	[ 10, 11, 12, -1, -1,   -1,  4, -1,  6, 14,   -1 ],
	[  8,  8,  8,  8,  8,    8,  8,  8,  8,  8,   -1 ],
	[ -1, -1, -1, -1, -1,   -1,  8,  8,  8,  8,   -1 ],
	[  7,  8,  9, 13, -1,   -1, -1, -1, -1, -1,   -1 ],
	[  4, -1,  6, 14, -1,   -1, -1, -1, -1, -1,   -1 ],
]

StageMap.NewCollsionData()
foreach(v in a)
	StageMap.AddCollisionData( v[0], v[1], v[2], v[3], v[4], v[5], v[6] )

for(local i=0; i < b.len(); ++i)
	for(local j=0; j < b[i].len(); ++j)
		StageMap.AttachCollisionData( b[i][j], i, j )
